#!/usr/bin/python3

import sys
# ukljucujemo biblioteku numpy
import numpy as np

# pravimo numPy niz na osnovu liste
a = np.array([1,2,3])
# obican python niz (array.array) je uvek jednodimenziona kolekcija
# dok numpy niz (numpy.array) podrzava proizvoljan broj dimenzija

# da bismo prikazali kreirani niz, koristimo funkciju print
print(a)

# ako hocemo da saznamo kog tipa je neka promenljiva koristimo funkciju type
print(type(a))
# ako hocemo da saznamo dimenziju niza, treba nam atribut 'shape' promenljive
# tipa numpy.array
print(a.shape)

# kao i klasicni nizovi, i numpy nizovi podrzavaju indeksni prisup
# indeksiranje pocinje od 0
print(a[0], a[1], a[2])
# nump.array je mutabilna kolekcija, tj. mozemo da menjamo njene elemente
a[0] = 5
# stampamo izmenjeni niz
print(a)

# visedimenzioni nizovi se kreiraju tako sto kreiramo listu cije je svaki element druga lista
# na primer, hocemo da kreriramo dvodimenzioni niz
b = np.array([[1, 2, 3], [4,5,6]]);

# da bismo se uverili da je zaista u pitanju dvodimenzioni niz, mozemo da saznamo njegovu
# dimenziju
print(b.shape)

# indeksiranje visedimenzionih nizova je takodje moguce, pri cemu neophodan broj indeksa
# odgovara broju dimenzija. npr. dvodimenzioni niz zahteva dva indeksa
print(b[0,0], b[0,1], b[1,0])

# pored rucnog kreiranja nizova, numpy podrzava i skup funkcija koje automatski kreiraju
# nizove zeljenih dimenzija sa unapred predefinisanim svojstvima

# slicno Matlabu, nula niz dimenzije 2x2 dobijamo sledecom naredbom
a = np.zeros((2,2))
# stampamo kreirani niz
print(a)

# niz jedinica dimenzije 3x2 dobijamo sledecom naredbom
b = np.ones((3,2))
# stampamo kreirani niz
print(b)


# konstantni niz dimenzije 2x3 dobijamo sledecom naredbom
c = np.full((3,2), 7)
# stampamo kreirani niz
print(c)

# jednicni niz dimenzije 3x3 dobijamo sledecom naredbom
d = np.eye(3)
# stampamo kreirani niz
print(d)

# niz slucajnih brojeva dimenzija 2x2 dobijamo sledecom naredbom
e = np.random.random((2,2))
# stampamo kreirani niz
print(e)

# jos jedan nacin za kreiranje nizova je i funkcija arange
# kojom se kreiraju sekvence
# opsti oblik poziva je arange(donja_granica, gornja_granica, korak)
# ukoliko se izostavi donja granica podrazumeva se da je 0
# ukoliko se izostavi korak podrazumeva se da je 1
f = np.arange(10)
print(f)

g = np.arange(5, 10)
print(g)

h = np.arange(5,10,2)
print(h)

# slicno Matlabu, moguce je kreirati proizvoljne ekvidistantne podele
# na unapred zadatom intervalu. za to se koristi funkcija linspace
print(np.linspace(1., 10., 20))


