#!/usr/bin/python3

import sys
# ukljucujemo biblioteku numpy
import numpy as np

# pored definisanja tipova, numpy biblioteka podrzava 
# gotovo sve uobicajene aritmeticke operacije nad numpy.array tipom

# definisemo dva niza koja cemo koristiti kao operande
x = np.array([[1,2],[3,4]], dtype=np.float64)
y = np.array([[5,6],[7,8]], dtype=np.float64)

# sabiranje nizova je pokoordinatno i rezultat ce biti iste
# dimenzije kao i operandi. Operandi moraju biti iste dimenzije,
# inace se opracija ne moze primeniti i dobice se ValueError
print(x + y)
print(np.add(x, y))

# oduzimanje nizova je pokoordinatno i rezultat ce biti iste
# dimenzije kao i operandi. Operandi moraju biti iste dimenzije,
# inace se opracija ne moze primeniti i dobice se ValueError

print(x - y)
print(np.subtract(x, y))

# deljenje nizova je pokoordinatno i rezultat ce biti iste
# dimenzije kao i operandi. Operandi moraju biti iste dimenzije,
# inace se opracija ne moze primeniti i dobice se ValueError
print(x * y)
print(np.multiply(x, y))

# ako ste ranije koristili Matlab, ovo nije ocekivano ponasanje, pa povedite racuna 
# kada mnozite numpy nizove

# deljenje nizova je pokoordinatno i rezultat ce biti iste
# dimenzije kao i operandi. Operandi moraju biti iste dimenzije,
# inace se opracija ne moze primeniti i dobice se ValueError
print(x / y)
print(np.divide(x, y))

# primena korena je takodje pokoordinatna
print(np.sqrt(x))
# u ovom slucaju vazno je da koristimo pravu verziju korena
# s obzirom da radimo sa tipom podataka numpy.array potrebno je da koristimo
# koren, tj sqrt, iz numpy paketa.
# klasicni koren iz math paketa se ne moze primeniti na numpy tipove podataka.

# pored klasicnih pokoordinatnih operacija, numpy podrzava i operacije nad matricama

#definisemo dve 2x2 matrice
x = np.array([[1,2],[3,4]])
y = np.array([[5,6],[7,8]])

# definisemo dva vektora
v = np.array([9,10])
w = np.array([11, 12])

# unutrasnji, tj. skalarni  proizvod dva vektora. rezultat je broj
print(v.dot(w))
print(np.dot(v, w))

# proizvod matrice i vektora. rezultat je vektor
print(x.dot(v))
print(np.dot(x, v))

# proizvod dve matrice. Rezultat je matrica
print(x.dot(y))
print(np.dot(x, y))

# ako ste ranije koristili Matlab, ovo nije ocekivano ponasanje, pa povedite racuna 
# kada mnozite matrice. proizvod ne dobijate operatorom *, vec posebnom funkcijom dot

# matrice i vektore je moguce transponovati
print(x.T)
print(v.T)

# transponovanje vektora ne menja oblik polaznog vektora, tj. ne radi nista

# pored standardnih operacija sa nizovima, numpy podrzava i mnoge agregatne funkcije

# ako nam treba suma cele matrice, treba da koristimo funkciju sum
print(np.sum(x))
# sumu po kolonama ili vrstama dobijamo tako sto preciziramo po kojoj osi zelimo da se 
# izvrsi sabiranje

# suma po kolonama
print(np.sum(x, axis=0)) 
# suma po vrstama
print(np.sum(x, axis=1))

# pored funkcije sum, korisne su jos operacije
# average - prosek
# mean - srednja vrednost
# std - standardna devijacija
# var - varijansa
# amax - maksimum
# amin - minimum

