#!/usr/bin/python3

import sys
import numpy as np
import scipy.integrate

# hocemo da nadjemo vrednost integrala funkcije e^(-x^2) na intervalu 0,1

# prvo definisemo lambda izraz koji opisuje nasu funkciju
f = lambda x: np.exp(-x**2)
# racunamo vrednost integrala pomocu funkcije quad iz scipy paketa
# argumenti funkcije su podintegralna funkcija i granice integraljenja
i = scipy.integrate.quad(f, 0, 1)
# prikazujemo dobijeni rezultat
print(i)
# prvi broj u rezultatu je vrednost integrala, a drugi broj je ocena apsolutne greske integrala

# na slican nacin mogu se racunati i dvostruki (dblqaud), trostruki (tplquad) i n-tostruki (nquad) integral

# u narednom primer izracunavamo dvostruki integral funkcije 16xy pri cemu su granice integraljenja po x 0 i sqrt(1 - 4y^2),
# a granice integraljenja po y su 0 i 1/2
# da bismo to uradili treba nam funkcija dblquad iz paketa scipy.integrate
# argumenti funkcije dblquad su podintegralna funkcija, granice integraljenja za x i granice integraljenja za y
# granice integraljenja za y se uvek moraju zadati kao funkcije, cak i kada se radi o konstantama

# prvo definisemo lambda izraz koji opisuje podintegralnu funkciju
f = lambda x,y: 16*x*y
# a nakon toga definisemo lambde koje opisuju granice integraljenja po x

# donja granica
# iako se radi o konstanti, moramo da je definisemo kao funkciju pomocu lambda izraza
g = lambda x : 0
# gornja granica
h = lambda y: np.sqrt(1 - 4*y**2)
# izracunavamo integral
ii = scipy.integrate.dblquad(f, 0, 0.5, g, h)
# stampamo dobijeni rezultat
print(ii)

