#!/usr/bin/python3

import sys
import numpy as np
import scipy.linalg as sc

# pored integraljenja i interpolacije, scipy podrzava i skup
# funkcija za resavanje algebarskih problema

# pomocu funkcije solve mozemo da resavamo sisteme jednacina oblika Ax=basestring

# prvo definisemo matricu sistema
A = np.array([[3,2,0],[1,-1,0],[0,5,1]])
# definisemo slobodni vektor
b = np.array([2,4,-1])

# resavamo sistem Ax = b pomocu funkcije solve
x = sc.solve(A,b)

# prikazujemo dobijeno resenje
print(x)

# pomocu funkcije det, mozemo da pronadjemo determinantu matrice

# definisemo matricu
A = np.array([[1,2],[3,4]])
# izracunavamo determinantu
x = sc.det(A)

#stampamo dobijeni rezultat
print(x)

# da bismo nasli inverznu matricu treba da koristimo funkciju inv
A_1 = sc.inv(A)
# stampamo inverznu matricu
print(A_1)
# proveravamo dobijeni rezultat
print(np.dot(A, A_1))


# pored determinante i inverzne matrice, mozemo da izracunamo i sopstvene vektore i sopstvene vrednosti matrice
# da bismo to postigli, treba nam funkcija eig
l, v = sc.eig(A)

# stmapamo sopstvene vrednosti
print(l)

# stampamo sopstvene vektore
print(v)

