#!/usr/bin/python3

import sys
import numpy as np
from scipy.spatial import ConvexHull
import matplotlib.pyplot as plt

# cest problem u matematici i racunarstvu je pronalazenje konveksnog omotaca
# biblioteka scipy nam omogucava da lako pronadjemo konveksni omotac skupa tacaka

# kreiramo niz trideset slucajnih tacaka u ravni
points = np.random.rand(30,2)

# izracunavamo konvekstni omotac skupa tacaka
hull = ConvexHull(points)

# graficki priakzujemo dobijene rezultate

# kreiramo novu figuru
plt.figure(num = 1)

# crtamo skup tacaka
plt.plot(points[:,0], points[:,1], 'o')
# crtamo omotac liniju po liniju
for simplex in hull.simplices:
	plt.plot(points[simplex,0], points[simplex,1], 'k-')
# prikazujemo dobijeni grafik
plt.show()