#!/usr/bin/python3

import sys
from sympy import *
init_printing(use_unicode=True)

# prvo definisemo simbole
x = Symbol('x')
y = Symbol('y')

# za resavanje jednacina u paketu sympy koristi se funkcija solve.
# prvi argument funkcije je jedancina koju treba resiti, a drugi je 
# promenljiva po kojoj treba resiti jednacinu

# na primer, hocemo da nadjemo resenja x**4 - 1 == 0
print(solve(x**4 - 1, x))

# u slucaju da resavamo sistem jednacina, potrebno je da argumente
# prosledimo funkciji kao liste.
print(solve([x + 5*y - 2, -3*x + 6*y - 15], [x, y]))

# pored algebraskih jednacina, solve ume da resi i neke nelinearne jednacine
# poput
print(solve(exp(x) + 1, x))

# u opstem slucaju, solve se koristi iskljucivo za resavanje algebraskih jednacina

# pored algebraskih jednacina , sympy ume da resava i bulovske jednacine. U tu svrhu se koristi
# funkcija satisfiable
print(satisfiable(x & y))
print(satisfiable(x & ~x))


