#!/usr/bin/python3

import sys
from sympy import *
init_printing(use_unicode=True)

# u sympy biblioteci matrice se definisu funkcijom Matrix
# i mogu da sadrze brojeve i simbole

# kreiramo matricu
M = Matrix([[1, -1], [3, 4], [0, 2]])
# prikazujemo kreiranu matricu
print(M)

# kreiramo novu matricu
M = Matrix([[1, 2, 3], [3, 2, 1]])
# kreiramo slobodan vektor
N = Matrix([0, 1, 1])
# mnozimo matricu i vektor i stampamo rezultat
print(M*N)
# dimenzije matrice dobijamo pomocu polja shape
print(M.shape)

# pristup vrstama i kolonama se postize pomocu polja row i col

# stampamo prvu vrstu
print(M.row(0))
# stampamop poslednju kolonu
print(M.col(-1))
# indeksiranje je isto kao kod stringova

# uklanjanje kolona se vrsi pomocu funkcije col_del, a uklanjanje vrsta pomocu
# funkcije row_del. Uklanjanje modifikuje postojecu matricu

# uklanjamo prvu kolonu
M.col_del(0)
# stampamo smanjenu matricu
print(M)

# uklanjamo drugu vrstu
M.row_del(1)
# stampamo smanjenu matricu
print(M)

# dodavanje kolona se radi pomocu funkcije col_insert, a vrsta pomocu funkcije row_insert
# dodavanje vrsta i/ili kolona kreira novu matricu, a stara ostaje nepromenjena


# dodajemo vrstu na kraj matrice
# kreiramo novu matricu i pamtimo je pod starim imenom
M = M.row_insert(1, Matrix([[0, 4]]))
# stampamo novu matricu
print(M)

# dodajemo kolonu na pocetak matrice
# kreiramo novu matricu i pamtimo je pod starim imenom
M = M.col_insert(0, Matrix([1, -2]))
# stampamo dobijenu matricu

# sympy podrzava i sve klasicne operacije sa matricama

# kreiramo dve nove matrice
M = Matrix([[1, 3], [-2, 3]])
N = Matrix([[0, 3], [0, 7]])

print(M+N)
print(M-N)
print(M*N)
print(3*M)
print(M**2)
# inverzna matrica
print(M**-1)
# matrica N ima determinantu jednaku 0, pa nema inverznu matricu
# nakon ove naredbe trebalo bi da dobijemo ValueError
try:
	print(N**-1)
except (ValueError):
	print('Matrica nije invertibilna')

# transponovana matrica
print(M.T)
print(N.T)

# determinanta matrice
print(M.det())
print(N.det())

# sopstvene vrednosti matrice se racunaju pomocu funkcije eigenvals
# a sopstveni vektori se racunaju pomocu funkcije eigenvects

# kreiramo matricu M
M = Matrix([[3, -2,  4, -2], [5,  3, -3, -2], [5, -2,  2, -2], [5, -2, -3,  3]])
# izracunavamo sopstvene vrednosti
print(M.eigenvals())

# izracunavamo sopstvene vektore
print(M.eigenvects())

# da bismo dijagonalizovali matricu koristimo funkcije diagonalize
P, D = M.diagonalize();
print(P*D*P**-1)
print(P*D*P**-1 == M)
